@echo off

setlocal

set EL_Error=0
set EL_NoError=1
set EL_NoMatch=1
set EL_Matched=2

set BUILD=%1
if defined BUILD goto :HaveBuild
echo Usage: 
echo    ErrorLevel Debug^|Release
echo.
echo Tests errorlevel return values from the specified regx build
goto :EOF

:: ==============================================================
:HaveBuild


set regx=..\bin\%BUILD%\regx.exe

:: ==============================================================
:: Test 1 - no params should return NoError
:Test1
%regx% > nul:
if %ERRORLEVEL% neq %EL_NOERROR% goto :Test1_fail
:Test1_OK
echo Test 1 - OK
goto :Test2
:Test1_Fail
echo Test 1 failed. Errorlevel was supposed to be %EL_NOERROR% but came back as %ERRORLEVEL%
goto :Test2

:: ==============================================================
:: Test 2 - /Debug should return NoError 
:Test2
%regx% AAA /Debug /ErrorsToStdOut > nul:
if %ERRORLEVEL% neq %EL_NOERROR% goto :Test2_fail
:Test2_OK
echo Test 2 - OK
goto :Test3
:Test2_Fail
echo Test 2 failed. Call with /Debug should return %EL_NOERROR% but returned %ERRORLEVEL%
goto :Test3

:: ==============================================================
:: Test 3 - Error should return EL_Error
:Test3
%regx% /ErrorsToStdOut /f errorlevel.cmd > nul:
if %ERRORLEVEL% neq %EL_ERROR% goto :Test3_fail
:Test3_OK
echo Test 3 - OK
goto :Test4
:Test3_Fail
echo Test 3 failed. Call with no pattern should return %EL_ERROR% but returned %ERRORLEVEL%
goto :Test4

:: ==============================================================
:: Test 4 - File search that matches should return EL_Matched
:Test4
:Test4_OK
%regx% one /ErrorsToStdOut /f TestDataA.txt > nul:
if %ERRORLEVEL% neq %EL_MATCHED% goto :Test5_fail
echo Test 4 - OK
goto :Test5
:Test4_Fail
echo Test 4 failed. Matched file search should return %EL_MATCHED% but returned %ERRORLEVEL%
goto :Test5

:: ==============================================================
:: Test 5 - File search that doesn't match should return EL_NoMatch
:Test5
%regx% nineteen /ErrorsToStdOut /f TestDataA.txt > nul:
if %ERRORLEVEL% neq %EL_NOMATCH% goto :Test5_fail
:Test5_OK
echo Test 5 - OK
goto :Test6
:Test5_Fail
echo Test 5 failed. Unmatched file search should return %EL_NOMATCH% but returned %ERRORLEVEL%
goto :Test6

:: ==============================================================
:: Test 6 - Filter search that matches should return EL_Matched
:Test6
echo aa bb cc | %regx% bb /ErrorsToStdOut > nul:
:Test6_OK
echo Test 6 - OK
goto :Test7
:Test6_Fail
echo Test 6 failed. Matched filter search should return %EL_MATCHED% but returned %ERRORLEVEL%
goto :Test7

:: ==============================================================
:: Test 7 - Filter search that doesn't match should return EL_NoMatch
:Test7
echo aa bb cc | %regx% qq /ErrorsToStdOut > nul:
:Test7_OK
echo Test 7 - OK
goto :Test8
:Test7_Fail
echo Test 7 failed. Unmatched filter search should return %EL_NOMATCH% but returned %ERRORLEVEL%
goto :Test8

:: ==============================================================
:: Test 8 - Url search that matches should return EL_Matched
:Test8
%regx% "<" /ErrorsToStdOut /url www.bing.com > nul:
:Test8_OK
echo Test 8 - OK
goto :Test9
:Test8_Fail
echo Test 8 failed. Matched url search should return %EL_MATCHED% but returned %ERRORLEVEL%
goto :Test9

:: ==============================================================
:: Test 9 - Url search that doesn't match should return EL_NoMatch
:Test9
%regx% "caecilian" /ErrorsToStdOut /url www.bing.com > nul:
:Test9_OK
echo Test 9 - OK
goto :Test10
:Test9_Fail
echo Test 9 failed. Unmatched url search should return %EL_NOMATCH% but returned %ERRORLEVEL%
goto :Test10


:Test10

:: ==============================================================
:: Test N - 
:TestN
:TestN_OK
goto :TestM
:TestN_Fail
goto :TestM

:TestM